 
public class MultipleAlignment_3 {


    public static void main(String[] args) {
        // Ueberpruefung der Parameter
        if (args.length != 3) {
            System.out.println("Bitte das naechste Mal drei Strings eingeben.");
        } else {
            multAlign(args[0], args[1], args[2]);
        }

    }


    private static void multAlign(String s1, String s2, String s3) {
        // Datenstrukturen werden angelegt
        // Matrix zur normalen Berechnung
        int[][][] matrix = new int[s1.length()+1][s2.length()+1][s3.length()+1];
        // Matrix fuer backtracing
        String[][][] traceback = new String[s1.length()+1][s2.length()+1][s3.length()+1];
        


        // Initialisierung des (0,0,0) Feldes
        matrix[0][0][0] = 0;
        traceback[0][0][0] = "000";



        // Initialisierung der Seitenflaechen, insgesamt drei Stueck
        // (0, 1, 1)
        for (int i = 1; i < matrix[0].length;i++) {
            matrix[0][i][0] = i;
            traceback[0][i][0] = "010";
        }
        for (int j = 1; j < matrix[0][0].length; j++) {
            matrix[0][0][j] = j;
            traceback[0][0][j] = "001";
        }
        for (int i = 1; i < matrix[0].length; i++) {
            for (int j = 1; j < matrix[0][0].length; j++) {
                //speichert den geringsten Wert
                int min;
                // wird fuers backtracing gebraucht, speichert, aus welcher Richtung 
                // niedrigster Wert kam
                String way;
                // Berechnung der Werte ausgehend von drei Vorgaengern
                int z1 = matrix[0][i-1][j] + sop(' ', s2.charAt(i-1), ' ');
                min = z1;
                way = "010";
                int z2 = matrix[0][i-1][j-1] + sop(' ', s2.charAt(i-1), s3.charAt(j-1));
                if (z2 < min) {
                    min = z2;
                    way = "011";
                }
                int z3 = matrix[0][i][j-1] + sop(' ', ' ', s3.charAt(j-1));
                if (z3 < min) {
                    min = z3;
                    way = "001";
                }
                // minimaler Wert und Wegstueck werden gespeichert
                matrix[0][i][j] = min;
                traceback[0][i][j] = way;
            }
        }
        // (1,0,1)
        for (int i = 1; i < matrix.length; i++) {
            matrix[i][0][0] = i;
            traceback[i][0][0] = "100";
        }
/*        for (int j = 1; j < matrix[0][0].length;j++){
            matrix[0][0][j] = j;
        }*/
        for (int i = 1; i < matrix.length; i++) {
            for (int j = 1; j < matrix[0][0].length; j++) {
                int min;
                String way;
                int z1 = matrix[i-1][0][j] + sop(s1.charAt(i-1), ' ', ' ');
                min = z1;
                way = "100";
                int z2 = matrix[i-1][0][j-1] + sop(s1.charAt(i-1), ' ', s3.charAt(j-1));
                if (z2 < min) {
                    min = z2;
                    way = "101";
                }
                int z3 = matrix[i][0][j-1] + sop(' ', ' ', s3.charAt(j-1));
                if (z3 < min) {
                    min = z3;
                    way = "001";
                }
                matrix[i][0][j] = min;
                traceback[i][0][j] = way;
            }
        }
        // (1,1,0)
/*        for (int i = 1; i < matrix.length; i++) {
            matrix[i][0][0] = i;
        }
        for (int j = 0; j < matrix[0].length; j++){
            matrix[0][j][0] = j;
        }*/
        for (int i = 1; i < matrix.length; i++){
            for (int j = 1; j < matrix[0].length; j++){
                int min;
                String way;
                int z1 = matrix[i-1][j][0] + sop(s1.charAt(i-1), ' ', ' ');
                min = z1;
                way = "100";
                int z2 = matrix[i-1][j-1][0] + sop(s1.charAt(i-1), s2.charAt(j-1), ' ');
                if (z2 < min) {
                    min = z2;
                    way = "110";
                }
                int z3 = matrix[i][j-1][0] + sop(' ', s2.charAt(j-1), ' ');
                if (z3 < min) {
                    min = z3;
                    way = "010";
                }
                matrix[i][j][0] = min;
                traceback[i][j][0] = way;
            }
        }

        //normale Berechung nach der Initialisierung
        for (int i = 1; i < matrix.length; i++) {
            for (int j = 1; j < matrix[0].length; j++) {
                for (int k = 1; k < matrix[0][0].length; k++) {
                    int min;
                    String way;
                    // Berechnung von Werten durch sieben Vorgaengern
                    int z1 = matrix[i][j][k-1] + sop(' ', ' ', s3.charAt(k-1));
                    min = z1;
                    way = "001";
                    int z2 = matrix[i][j-1][k] + sop(' ', s2.charAt(j-1), ' ');
                    if (z2 < min) {
                        min = z2;
                        way = "010";
                    }
                    int z3 = matrix[i][j-1][k-1] + sop(' ', s2.charAt(j-1), s3.charAt(k-1));
                    if (z3 < min) {
                        min = z3;
                        way = "011";
                    }
                    int z4 = matrix[i-1][j][k] + sop(s1.charAt(i-1), ' ', ' ');
                    if (z4 < min) {
                        min = z4;
                        way = "100";
                    }
                    int z5 = matrix[i-1][j][k-1] + sop(s1.charAt(i-1), ' ', s3.charAt(k-1));
                    if (z5 < min) {
                        min = z5;
                        way = "101";
                    }
                    int z6 = matrix[i-1][j-1][k] + sop(s1.charAt(i-1), s2.charAt(j-1), ' ');
                    if (z6 < min) {
                        min = z6;
                        way = "110";
                    }
                    int z7 = matrix[i-1][j-1][k-1] + sop(s1.charAt(i-1), s2.charAt(j-1), s3.charAt(k-1));
                    if (z7 < min) {
                        min = z7;
                        way = "111";
                    }
                    matrix[i][j][k] = min;
                    traceback[i][j][k] = way;
                }
            }
        }





        for (int i = 0; i < matrix.length; i++) {
            for (int j = 0; j < matrix[0].length; j++) {
                for (int k = 0; k < matrix[0][0].length; k++) {
                    System.out.print(matrix[i][j][k] + " ");
                }
                System.out.println();
            }
            System.out.println();
        }
        System.out.println("Endergebnis: " + matrix[s1.length()][s2.length()][s3.length()]);

        System.out.println("Und der Weg zurueck");
        for (int i = 0; i < traceback.length; i++) {
            for (int j = 0; j < traceback[0].length; j++) {
                for (int k = 0; k < traceback[0][0].length; k++) {
                    System.out.print(traceback[i][j][k] + " ");
                }
                System.out.println();
            }
            System.out.println();
        }


    }



    // Berechnet den Sum of pairs Score fuer eine Alignment Spalte
    private static int sop (char c1, char c2, char c3) {
        int cost = 0;
        if (c1 != c2) {
            cost ++;
        }
        if (c1 != c3) {
            cost ++;
        }
        if (c2 != c3) {
            cost ++;
        }
        return cost;
    }





}
